using System;
using SKYPE4COMLib;

namespace Wra4Skype.Library
{
    public interface IViewModel
    {
        event EventHandler InvitationReceived;

        event EventHandler UsersLoaded;

        InvitationMessage LastInvitation { get; }

        void AcceptLastInvitation();

        void Connect();

        void Disconnect();

        void SendInvitation(string user);

        UserCollection Users { get; }
    }
}