using System;

namespace Wra4Skype.Library
{
    public interface ILogger
    {
        void Info(string message);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Error", Justification = "Using this reserved word here is ok")]
        void Error(string message);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716:IdentifiersShouldNotMatchKeywords", MessageId = "Error", Justification = "Using this reserved word here is ok")]
        void Error(string message, Exception exception);

        void Debug(string message);

        void Warn(string message);

        void Warn(string message, Exception exception);
    }
}